<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ServerAdminClient.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">ServerAdminClient.java</span></div><h1>ServerAdminClient.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.nio.ByteBuffer;
import java.util.StringTokenizer;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.zookeeper.server.ZooTrace;

<span class="nc bnc" id="L34" title="All 2 branches missed.">public class ServerAdminClient {</span>
<span class="nc" id="L35">    private static final Logger LOG = LoggerFactory.getLogger(ServerAdminClient.class);</span>

    private static long getMask(String mask) {
<span class="nc" id="L38">        long retv = 0;</span>
<span class="nc bnc" id="L39" title="All 2 branches missed.">        if (mask.equalsIgnoreCase(&quot;CLIENT_REQUEST_TRACE_MASK&quot;)) {</span>
<span class="nc" id="L40">            retv = ZooTrace.CLIENT_REQUEST_TRACE_MASK;</span>
<span class="nc bnc" id="L41" title="All 2 branches missed.">        } else if (mask.equalsIgnoreCase(&quot;CLIENT_DATA_PACKET_TRACE_MASK&quot;)) {</span>
<span class="nc" id="L42">            retv = ZooTrace.CLIENT_DATA_PACKET_TRACE_MASK;</span>
<span class="nc bnc" id="L43" title="All 2 branches missed.">        } else if (mask.equalsIgnoreCase(&quot;CLIENT_PING_TRACE_MASK&quot;)) {</span>
<span class="nc" id="L44">            retv = ZooTrace.CLIENT_PING_TRACE_MASK;</span>
<span class="nc bnc" id="L45" title="All 2 branches missed.">        } else if (mask.equalsIgnoreCase(&quot;SERVER_PACKET_TRACE_MASK&quot;)) {</span>
<span class="nc" id="L46">            retv = ZooTrace.SERVER_PACKET_TRACE_MASK;</span>
<span class="nc bnc" id="L47" title="All 2 branches missed.">        } else if (mask.equalsIgnoreCase(&quot;SESSION_TRACE_MASK&quot;)) {</span>
<span class="nc" id="L48">            retv = ZooTrace.SESSION_TRACE_MASK;</span>
<span class="nc bnc" id="L49" title="All 2 branches missed.">        } else if (mask.equalsIgnoreCase(&quot;EVENT_DELIVERY_TRACE_MASK&quot;)) {</span>
<span class="nc" id="L50">            retv = ZooTrace.EVENT_DELIVERY_TRACE_MASK;</span>
<span class="nc bnc" id="L51" title="All 2 branches missed.">        } else if (mask.equalsIgnoreCase(&quot;SERVER_PING_TRACE_MASK&quot;)) {</span>
<span class="nc" id="L52">            retv = ZooTrace.SERVER_PING_TRACE_MASK;</span>
<span class="nc bnc" id="L53" title="All 2 branches missed.">        } else if (mask.equalsIgnoreCase(&quot;WARNING_TRACE_MASK&quot;)) {</span>
<span class="nc" id="L54">            retv = ZooTrace.WARNING_TRACE_MASK;</span>
        }
<span class="nc" id="L56">        return retv;</span>
    }

    private static long getMasks(String masks) {
<span class="nc" id="L60">        long retv = 0;</span>
<span class="nc" id="L61">        StringTokenizer st = new StringTokenizer(masks, &quot;|&quot;);</span>
<span class="nc bnc" id="L62" title="All 2 branches missed.">        while (st.hasMoreTokens()) {</span>
<span class="nc" id="L63">            String mask = st.nextToken().trim();</span>
<span class="nc" id="L64">            retv = retv | getMask(mask);</span>
<span class="nc" id="L65">        }</span>
<span class="nc" id="L66">        return retv;</span>
    }

    public static void ruok(String host, int port) {
<span class="nc" id="L70">        Socket s = null;</span>
        try {
<span class="nc" id="L72">            byte[] reqBytes = new byte[4];</span>
<span class="nc" id="L73">            ByteBuffer req = ByteBuffer.wrap(reqBytes);</span>
<span class="nc" id="L74">            req.putInt(ByteBuffer.wrap(&quot;ruok&quot;.getBytes()).getInt());</span>
<span class="nc" id="L75">            s = new Socket();</span>
<span class="nc" id="L76">            s.setSoLinger(false, 10);</span>
<span class="nc" id="L77">            s.setSoTimeout(20000);</span>
<span class="nc" id="L78">            s.connect(new InetSocketAddress(host, port));</span>

<span class="nc" id="L80">            InputStream is = s.getInputStream();</span>
<span class="nc" id="L81">            OutputStream os = s.getOutputStream();</span>

<span class="nc" id="L83">            os.write(reqBytes);</span>

<span class="nc" id="L85">            byte[] resBytes = new byte[4];</span>

<span class="nc" id="L87">            int rc = is.read(resBytes);</span>
<span class="nc" id="L88">            String retv = new String(resBytes);</span>
<span class="nc" id="L89">            System.out.println(&quot;rc=&quot; + rc + &quot; retv=&quot; + retv);</span>
<span class="nc" id="L90">        } catch (IOException e) {</span>
<span class="nc" id="L91">            LOG.warn(&quot;Unexpected exception&quot;, e);</span>
        } finally {
<span class="nc bnc" id="L93" title="All 6 branches missed.">            if (s != null) {</span>
                try {
<span class="nc" id="L95">                    s.close();</span>
<span class="nc" id="L96">                } catch (IOException e) {</span>
<span class="nc" id="L97">                    LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="nc" id="L98">                }</span>
            }
        }
<span class="nc" id="L101">    }</span>

    public static void dump(String host, int port) {
<span class="nc" id="L104">        Socket s = null;</span>
        try {
<span class="nc" id="L106">            byte[] reqBytes = new byte[4];</span>
<span class="nc" id="L107">            ByteBuffer req = ByteBuffer.wrap(reqBytes);</span>
<span class="nc" id="L108">            req.putInt(ByteBuffer.wrap(&quot;dump&quot;.getBytes()).getInt());</span>
<span class="nc" id="L109">            s = new Socket();</span>
<span class="nc" id="L110">            s.setSoLinger(false, 10);</span>
<span class="nc" id="L111">            s.setSoTimeout(20000);</span>
<span class="nc" id="L112">            s.connect(new InetSocketAddress(host, port));</span>

<span class="nc" id="L114">            InputStream is = s.getInputStream();</span>
<span class="nc" id="L115">            OutputStream os = s.getOutputStream();</span>

<span class="nc" id="L117">            os.write(reqBytes);</span>

<span class="nc" id="L119">            byte[] resBytes = new byte[1024];</span>

<span class="nc" id="L121">            int rc = is.read(resBytes);</span>
<span class="nc" id="L122">            String retv = new String(resBytes);</span>
<span class="nc" id="L123">            System.out.println(&quot;rc=&quot; + rc + &quot; retv=&quot; + retv);</span>
<span class="nc" id="L124">        } catch (IOException e) {</span>
<span class="nc" id="L125">            LOG.warn(&quot;Unexpected exception&quot;, e);</span>
        } finally {
<span class="nc bnc" id="L127" title="All 6 branches missed.">            if (s != null) {</span>
                try {
<span class="nc" id="L129">                    s.close();</span>
<span class="nc" id="L130">                } catch (IOException e) {</span>
<span class="nc" id="L131">                    LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="nc" id="L132">                }</span>
            }
        }
<span class="nc" id="L135">    }</span>

    public static void stat(String host, int port) {
<span class="nc" id="L138">        Socket s = null;</span>
        try {
<span class="nc" id="L140">            byte[] reqBytes = new byte[4];</span>
<span class="nc" id="L141">            ByteBuffer req = ByteBuffer.wrap(reqBytes);</span>
<span class="nc" id="L142">            req.putInt(ByteBuffer.wrap(&quot;stat&quot;.getBytes()).getInt());</span>
<span class="nc" id="L143">            s = new Socket();</span>
<span class="nc" id="L144">            s.setSoLinger(false, 10);</span>
<span class="nc" id="L145">            s.setSoTimeout(20000);</span>
<span class="nc" id="L146">            s.connect(new InetSocketAddress(host, port));</span>

<span class="nc" id="L148">            InputStream is = s.getInputStream();</span>
<span class="nc" id="L149">            OutputStream os = s.getOutputStream();</span>

<span class="nc" id="L151">            os.write(reqBytes);</span>

<span class="nc" id="L153">            byte[] resBytes = new byte[1024];</span>

<span class="nc" id="L155">            int rc = is.read(resBytes);</span>
<span class="nc" id="L156">            String retv = new String(resBytes);</span>
<span class="nc" id="L157">            System.out.println(&quot;rc=&quot; + rc + &quot; retv=&quot; + retv);</span>
<span class="nc" id="L158">        } catch (IOException e) {</span>
<span class="nc" id="L159">            LOG.warn(&quot;Unexpected exception&quot;, e);</span>
        } finally {
<span class="nc bnc" id="L161" title="All 6 branches missed.">            if (s != null) {</span>
                try {
<span class="nc" id="L163">                    s.close();</span>
<span class="nc" id="L164">                } catch (IOException e) {</span>
<span class="nc" id="L165">                    LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="nc" id="L166">                }</span>
            }
        }
<span class="nc" id="L169">    }</span>

    public static void kill(String host, int port) {
<span class="nc" id="L172">        Socket s = null;</span>
        try {
<span class="nc" id="L174">            byte[] reqBytes = new byte[4];</span>
<span class="nc" id="L175">            ByteBuffer req = ByteBuffer.wrap(reqBytes);</span>
<span class="nc" id="L176">            req.putInt(ByteBuffer.wrap(&quot;kill&quot;.getBytes()).getInt());</span>
<span class="nc" id="L177">            s = new Socket();</span>
<span class="nc" id="L178">            s.setSoLinger(false, 10);</span>
<span class="nc" id="L179">            s.setSoTimeout(20000);</span>
<span class="nc" id="L180">            s.connect(new InetSocketAddress(host, port));</span>

<span class="nc" id="L182">            InputStream is = s.getInputStream();</span>
<span class="nc" id="L183">            OutputStream os = s.getOutputStream();</span>

<span class="nc" id="L185">            os.write(reqBytes);</span>
<span class="nc" id="L186">            byte[] resBytes = new byte[4];</span>

<span class="nc" id="L188">            int rc = is.read(resBytes);</span>
<span class="nc" id="L189">            String retv = new String(resBytes);</span>
<span class="nc" id="L190">            System.out.println(&quot;rc=&quot; + rc + &quot; retv=&quot; + retv);</span>
<span class="nc" id="L191">        } catch (IOException e) {</span>
<span class="nc" id="L192">            LOG.warn(&quot;Unexpected exception&quot;, e);</span>
        } finally {
<span class="nc bnc" id="L194" title="All 6 branches missed.">            if (s != null) {</span>
                try {
<span class="nc" id="L196">                    s.close();</span>
<span class="nc" id="L197">                } catch (IOException e) {</span>
<span class="nc" id="L198">                    LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="nc" id="L199">                }</span>
            }
        }
<span class="nc" id="L202">    }</span>

    public static void setTraceMask(String host, int port, String traceMaskStr) {
<span class="nc" id="L205">        Socket s = null;</span>
        try {
<span class="nc" id="L207">            byte[] reqBytes = new byte[12];</span>
<span class="nc" id="L208">            ByteBuffer req = ByteBuffer.wrap(reqBytes);</span>
<span class="nc" id="L209">            long traceMask = Long.parseLong(traceMaskStr, 8);</span>
<span class="nc" id="L210">            req.putInt(ByteBuffer.wrap(&quot;stmk&quot;.getBytes()).getInt());</span>
<span class="nc" id="L211">            req.putLong(traceMask);</span>

<span class="nc" id="L213">            s = new Socket();</span>
<span class="nc" id="L214">            s.setSoLinger(false, 10);</span>
<span class="nc" id="L215">            s.setSoTimeout(20000);</span>
<span class="nc" id="L216">            s.connect(new InetSocketAddress(host, port));</span>

<span class="nc" id="L218">            InputStream is = s.getInputStream();</span>
<span class="nc" id="L219">            OutputStream os = s.getOutputStream();</span>

<span class="nc" id="L221">            os.write(reqBytes);</span>

<span class="nc" id="L223">            byte[] resBytes = new byte[8];</span>

<span class="nc" id="L225">            int rc = is.read(resBytes);</span>
<span class="nc" id="L226">            ByteBuffer res = ByteBuffer.wrap(resBytes);</span>
<span class="nc" id="L227">            long retv = res.getLong();</span>
<span class="nc" id="L228">            System.out.println(&quot;rc=&quot; + rc + &quot; retv=0&quot;</span>
<span class="nc" id="L229">                    + Long.toOctalString(retv) + &quot; masks=0&quot;</span>
<span class="nc" id="L230">                    + Long.toOctalString(traceMask));</span>
<span class="nc bnc" id="L231" title="All 4 branches missed.">            assert (retv == traceMask);</span>
<span class="nc" id="L232">        } catch (IOException e) {</span>
<span class="nc" id="L233">            LOG.warn(&quot;Unexpected exception&quot;, e);</span>
        } finally {
<span class="nc bnc" id="L235" title="All 6 branches missed.">            if (s != null) {</span>
                try {
<span class="nc" id="L237">                    s.close();</span>
<span class="nc" id="L238">                } catch (IOException e) {</span>
<span class="nc" id="L239">                    LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="nc" id="L240">                }</span>
            }
        }
<span class="nc" id="L243">    }</span>

    public static void getTraceMask(String host, int port) {
<span class="nc" id="L246">        Socket s = null;</span>
        try {
<span class="nc" id="L248">            byte[] reqBytes = new byte[12];</span>
<span class="nc" id="L249">            ByteBuffer req = ByteBuffer.wrap(reqBytes);</span>
<span class="nc" id="L250">            req.putInt(ByteBuffer.wrap(&quot;gtmk&quot;.getBytes()).getInt());</span>

<span class="nc" id="L252">            s = new Socket();</span>
<span class="nc" id="L253">            s.setSoLinger(false, 10);</span>
<span class="nc" id="L254">            s.setSoTimeout(20000);</span>
<span class="nc" id="L255">            s.connect(new InetSocketAddress(host, port));</span>

<span class="nc" id="L257">            InputStream is = s.getInputStream();</span>
<span class="nc" id="L258">            OutputStream os = s.getOutputStream();</span>

<span class="nc" id="L260">            os.write(reqBytes);</span>

<span class="nc" id="L262">            byte[] resBytes = new byte[8];</span>

<span class="nc" id="L264">            int rc = is.read(resBytes);</span>
<span class="nc" id="L265">            ByteBuffer res = ByteBuffer.wrap(resBytes);</span>
<span class="nc" id="L266">            long retv = res.getLong();</span>
<span class="nc" id="L267">            System.out.println(&quot;rc=&quot; + rc + &quot; retv=0&quot;</span>
<span class="nc" id="L268">                    + Long.toOctalString(retv));</span>
<span class="nc" id="L269">        } catch (IOException e) {</span>
<span class="nc" id="L270">            LOG.warn(&quot;Unexpected exception&quot;, e);</span>
        } finally {
<span class="nc bnc" id="L272" title="All 6 branches missed.">            if (s != null) {</span>
                try {
<span class="nc" id="L274">                    s.close();</span>
<span class="nc" id="L275">                } catch (IOException e) {</span>
<span class="nc" id="L276">                    LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="nc" id="L277">                }</span>
            }
        }
<span class="nc" id="L280">    }</span>

    private static void usage() {
<span class="nc" id="L283">        System.out</span>
<span class="nc" id="L284">                .println(&quot;usage: java [-cp CLASSPATH] org.apache.zookeeper.ServerAdminClient &quot;</span>
                        + &quot;host port op (ruok|stat|dump|kill|gettracemask|settracemask) [arguments]&quot;);

<span class="nc" id="L287">    }</span>

    public static void main(String[] args) {
<span class="nc bnc" id="L290" title="All 2 branches missed.">        if (args.length &lt; 3) {</span>
<span class="nc" id="L291">            usage();</span>
<span class="nc" id="L292">            return;</span>
        }
<span class="nc" id="L294">        String host = args[0];</span>
<span class="nc" id="L295">        int port = Integer.parseInt(args[1]);</span>
<span class="nc" id="L296">        String op = args[2];</span>
<span class="nc bnc" id="L297" title="All 2 branches missed.">        if (op.equalsIgnoreCase(&quot;gettracemask&quot;)) {</span>
<span class="nc" id="L298">            getTraceMask(host, port);</span>
<span class="nc bnc" id="L299" title="All 2 branches missed.">        } else if (op.equalsIgnoreCase(&quot;settracemask&quot;)) {</span>
<span class="nc" id="L300">            setTraceMask(host, port, args[3]);</span>
<span class="nc bnc" id="L301" title="All 2 branches missed.">        } else if (op.equalsIgnoreCase(&quot;ruok&quot;)) {</span>
<span class="nc" id="L302">            ruok(host, port);</span>
<span class="nc bnc" id="L303" title="All 2 branches missed.">        } else if (op.equalsIgnoreCase(&quot;kill&quot;)) {</span>
<span class="nc" id="L304">            kill(host, port);</span>
<span class="nc bnc" id="L305" title="All 2 branches missed.">        } else if (op.equalsIgnoreCase(&quot;stat&quot;)) {</span>
<span class="nc" id="L306">            stat(host, port);</span>
<span class="nc bnc" id="L307" title="All 2 branches missed.">        } else if (op.equalsIgnoreCase(&quot;dump&quot;)) {</span>
<span class="nc" id="L308">            dump(host, port);</span>
        } else {
<span class="nc" id="L310">            System.out.println(&quot;Unrecognized op: &quot; + op);</span>
        }
<span class="nc" id="L312">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>